/*
  Name: Sinus and Cosinus Functions
  Copyright: 
  Author: Georgi N. Chakarov
  Date: 22.07.08 11:10
  Description: Uses a static array with values of the cosinus in the range of [0, Pi/2].
               It's a simplified and faster version of the trigonometric functions.
               Inputs an integer angle in degrees.
*/
static float cosa(int alpha);
static float sina(int alpha);

static float coss[46]={1, 0.999391, 0.997564, 0.994522, 0.990268, 0.984808, 0.978148, 0.970296, 0.961262,
						  0.951057, 0.939693, 0.927184, 0.913545, 0.898794, 0.882948, 0.866025, 0.848048,
 						  0.829038, 0.809017, 0.788011, 0.766044, 0.743145, 0.71934, 0.694658, 0.669131,
						  0.642788, 0.615661, 0.587785, 0.559193, 0.529919, 0.5, 0.469472, 0.438371, 0.406737,
                          0.374607, 0.34202, 0.309017, 0.275637, 0.241922, 0.207912, 0.173648, 0.139173,
                          0.104528, 0.0697565, 0.0348995, 0};


    static float cosa(int alpha)
    {
      	switch(alpha/90)
	  	{
          case 0: {return coss[(alpha)/2]; break;}
          case 1: {return -coss[(180-alpha)/2]; break;}
          case 2: {return -coss[(alpha-180)/2]; break;}
          case 3: {return coss[(360-alpha)/2]; break;}
        }
    }

    static float sina(int alpha)
    {
	    alpha-=90;	 
		if(alpha < 0) alpha+=360; 
	  	switch(alpha/90)
	  	{
          case 0: {return coss[(alpha)/2]; break;}
          case 1: {return -coss[(180-alpha)/2]; break;}
          case 2: {return -coss[(alpha-180)/2]; break;}
          case 3: {return coss[(360-alpha)/2]; break;}
        }
    }
 
