#include <iostream>
#include <string>
//#include "compass/compass.cpp"
using namespace std;

#define GPGGA 394
#define GPRMC 413

char buffer[80];
long int lat, lon;      // latitude longtitude altitude
char   N, E;            // direction symbols
float  course, alt;     // course in degrees relative to North 
double speed;           // speed over ground in m/s
char coord[16];          // coordinate ready for printing  

void read_coord(char);

void print()
{
    int i;  
    
    read_coord(N);
    cout << "Latitude: " << N << "" << coord << endl;
    read_coord(E);
 	cout << "Longtitude: " << E << "" << coord << endl;
 	cout << "Altitude: " << alt << endl;
 	cout << "Course: " << course << endl;
 	cout << "Speed: " << speed << endl << endl;
}

void read_buffer()  // dissect the message in the buffer
{ 
   //   1       2         3       4          5         6          7 8    9   10   11 12  13 14 15
   // $GPGGA,101624.000,4209.2194,N        ,02446.6210,E         ,1,03  ,2.3,124.2,M,37.1,M,   ,0000*5E
   // $GPRMC,101623.000,A        ,4209.2194,N         ,02446.6210,E,0.00,194.42,230708,,,A*6D

     
    int ID=0;         // ID of the NMEA message  
    int i;            // buffer position   
    int j;            // secondary buffer position  
    int segment=1;    // part which is read (between two commas)
    char dec_flag;   
    for(i=0; i<6; i++) ID += (int)buffer[i];
    
    switch(ID)
    {
       case GPRMC:
       {
          
          while(segment<13)  
          {
             switch(segment)
             {
                case 4:   // latitude segment
                {
                   j=i;
                   lat=0;
                   while(buffer[j]!=',')
                   {
                      if(buffer[j]=='.') {j++; continue; }
                      lat*=10;
                      lat+=buffer[j]-'0';
                      j++;
                   }  
                   i=j;  
                   break;
                }
                case 5:  // lattitude symbol segment
                {
                   N=buffer[i]; 
                   i++;
                   break;
                }
                case 6: // longtitude segment
                {
                   j=i;
                   lon=0;
                   while(buffer[j]!=',')
                   {
                      if(buffer[j]=='.') {j++; continue;}
                      lon*=10;
                      lon+=buffer[j]-'0';
                      j++;
                   }   
                   i=j;                
                   break;
                }
                case 7: // longtitude symbol segment
                { 
                   E=buffer[i];
                   i++;             
                   break;
                }
                case 8: // speed over ground segment
                {
                   j=i;
                   speed=0;
                   while(buffer[j]!=',')
                   {
                      if(buffer[j]=='.') {dec_flag=1; j++; continue; }
                      if(dec_flag) dec_flag++;
                      speed*=10;
                      speed+=buffer[j]-'0';
                      j++;
                   }        
                   while(dec_flag>1) {course/=10; dec_flag--;}           
                   speed*=0,51444;  // convert in m/s
                   i=j;
                   break;
                }
                case 9: // course over ground segment
                {
                   j=i;
                   course=0;
                   while(buffer[j]!=',')
                   {
                      if(buffer[j]=='.') {dec_flag=1; j++; continue;}
                      if(dec_flag) dec_flag++;
                      course*=10;
                      course+=buffer[j]-'0';
                      j++;
                   }        
                   while(dec_flag>1) {course/=10; dec_flag--;}  
                   dec_flag=0;  
                   i=j;       
                   break;
                }
             }

             if(buffer[i]==',') segment++; 
             i++;
          }
          break;
       }
       case GPGGA:
       {
          segment=0; 
          while(segment<14)  
          {  
             switch(segment)
             {
                case 9: // altitude segment
                {
                   j=i;
                   alt=0;
                   while(buffer[j]!=',')
                   {
                      if(buffer[j]=='.') { j++; continue;}
                      alt*=10;
                      alt+=buffer[j]-'0';
                      j++;
                   }     
                   alt/=10;
                   i=j;  
                   break;
                } 
             }

             if(buffer[i]==',') segment++; 
             i++;
          }
          break;
       }
    } 
}

void wait(int k)
{
  while(k>0) k--;
}

void read_coord(char cmd)
{
    int i;
    long int k;
    if(cmd=='N' || cmd == 'S') k=lat - lat%1000*0,4;
    if(cmd=='E' || cmd == 'W') k=lon - lon%1000*0,4;

    for(i=12; i>=0; i--)
    {
         if(i==12){ coord[i]='"'; continue;}
         if(i==9){ coord[i]='.'; continue;}
         if(i==6){ coord[i]='`'; continue;}
         if(i==3){ coord[i]='o'; continue;}
         coord[i]=k%10+'0';
         k/=10;
    }
    if(coord[0]=='0') coord[0]=' ';
}      
        

int main()
{
 	///int a;
 	///int n=36;
 	///cin >> a;
 	for(int i=0; i<12; i++)
 	{
         cin >> buffer; 
         read_buffer();
         print();
         wait(500);
        // system("CLS");
    }
    
   // draw_compass(a, n);
 	//cout << sina(a) << " " << cosa(a) << endl;
 	    
	system("PAUSE");
    return 0;
}
